{
    Файл является частью библиотеки RubiRobot

    © 2017 Слинкин Д.А.

    Базовый модуль библиотеки.
    Базовый класс, функции инициализации-завершения,
    набор предопределенных variant-переменных.

    Подробная информация о лицензировании находится в файле README,
    входящем в состав библиотеки.

    ДАННОЕ ПРОГРАММНОЕ ОБЕСПЕЧЕНИЕ ПРЕДОСТАВЛЯЕТСЯ «КАК ЕСТЬ», БЕЗ
    КАКИХ-ЛИБО ГАРАНТИЙ, ЯВНО ВЫРАЖЕННЫХ ИЛИ ПОДРАЗУМЕВАЕМЫХ,
    ВКЛЮЧАЯ ГАРАНТИИ ТОВАРНОЙ ПРИГОДНОСТИ, СООТВЕТСТВИЯ ПО ЕГО
    КОНКРЕТНОМУ НАЗНАЧЕНИЮ И ОТСУТСТВИЯ НАРУШЕНИЙ, НО НЕ ОГРАНИЧИВАЯСЬ 
    ИМИ. НИ В КАКОМ СЛУЧАЕ АВТОРЫ ИЛИ ПРАВООБЛАДАТЕЛИ НЕ НЕСУТ
    ОТВЕТСТВЕННОСТИ ПО КАКИМ-ЛИБО ИСКАМ, ЗА УЩЕРБ ИЛИ ПО ИНЫМ ТРЕБОВАНИЯМ,
    В ТОМ ЧИСЛЕ, ПРИ ДЕЙСТВИИ КОНТРАКТА, ДЕЛИКТЕ ИЛИ ИНОЙ СИТУАЦИИ,
    ВОЗНИКШИМ ИЗ-ЗА ИСПОЛЬЗОВАНИЯ ПРОГРАММНОГО ОБЕСПЕЧЕНИЯ ИЛИ ИНЫХ
    ДЕЙСТВИЙ С ПРОГРАММНЫМ ОБЕСПЕЧЕНИЕМ.

 **********************************************************************}

{$SMARTLINK ON}
{$mode objfpc}
{$H+}
unit uev3;

interface
 uses variants;

var
 // ms - время слипа в режиме ожидания события
 waitInterval:word=10;

type
  TEv3EventLink=(evAND,evOR);

  { TEv3 }

  TEv3=class
   public
    class function varToYes(yes:variant):boolean;
    // метод ожидания (блокировки) возникновения некоторого события
    // возвращает истину при достижении события и ложь при достижения таймаута
    // таймаут - в миллисекундах, при таймауте=0 - однократная проверка достижения
    function waitEvent(event:ansistring; timeout:dword=high(dword)):boolean; virtual; abstract;
    // метод ожидания возникновения событий на ВСЕХ переданых переданных объектах
    // Параметры передаются парами: объект-событие
    function waitAllEvents(objs:array of const; timeout:dword=high(dword)):boolean;
    // метод ожидания возникновения события на ХОТЯ-БЫ НА ОДНОМ ИЗ переданных объектов
    // Параметры передаются парами: объект-событие
    // Если событие возникло, возвращает первый объект, где оно возникло, иначе nil
    function waitAnyEvent(objs:array of const; timeout:dword=high(dword)):TEv3;
    // универсальное ожидание
    function waitEvents(Args:array of const; eLink:TEv3EventLink; out res:TEv3; timeout:dword=high(dword)):boolean;
    function waitEvents(Objs: array of TEv3; Events: array of string;
      eLink: TEv3EventLink; out res: TEv3; timeout: dword=high(dword)): boolean;
//    function sleep(ms:dword):;
  end;

var ev3:TEv3=nil;

  // вызов инициализции всех модулей.
  // перехват сигналов завершения работы (INT, ABRT, QUIT) с вызовом ev3Done
  procedure ev3Init();

type
  TInitProc=procedure;
  TDoneProc=procedure;
  // модуль, желающий инициализации, должен вызвать pushInit
  procedure PushInit(proc:tinitproc);
  // модуль, желающий инициализации, должен вызвать pushDone
  procedure PushDone(proc:tdoneproc);


var ev3finalized:boolean=false; // истина, если сейчас идет завершение работы

  // набор предопределенных переменных для произвольного использования
  var a,a0,a1,a2,a3,a4,a5,a6,a7,a8,a9:variant;
  var b,b0,b1,b2,b3,b4,b5,b6,b7,b8,b9:variant;
  var c,c0,c1,c2,c3,c4,c5,c6,c7,c8,c9:variant;
  var d,d0,d1,d2,d3,d4,d5,d6,d7,d8,d9:variant;
  var e,e0,e1,e2,e3,e4,e5,e6,e7,e8,e9:variant;
  var f,f0,f1,f2,f3,f4,f5,f6,f7,f8,f9:variant;
  var g,g0,g1,g2,g3,g4,g5,g6,g7,g8,g9:variant;
  var h,h0,h1,h2,h3,h4,h5,h6,h7,h8,h9:variant;
  var i,i0,i1,i2,i3,i4,i5,i6,i7,i8,i9:variant;
  var j,j0,j1,j2,j3,j4,j5,j6,j7,j8,j9:variant;
  var k,k0,k1,k2,k3,k4,k5,k6,k7,k8,k9:variant;
  var l,l0,l1,l2,l3,l4,l5,l6,l7,l8,l9:variant;
  var m,m0,m1,m2,m3,m4,m5,m6,m7,m8,m9:variant;
  var n,n0,n1,n2,n3,n4,n5,n6,n7,n8,n9:variant;
  var o,o0,o1,o2,o3,o4,o5,o6,o7,o8,o9:variant;
  var p,p0,p1,p2,p3,p4,p5,p6,p7,p8,p9:variant;
  var q,q0,q1,q2,q3,q4,q5,q6,q7,q8,q9:variant;
  var r,r0,r1,r2,r3,r4,r5,r6,r7,r8,r9:variant;
  var s,s0,s1,s2,s3,s4,s5,s6,s7,s8,s9:variant;
  var t,t0,t1,t2,t3,t4,t5,t6,t7,t8,t9:variant;
  var u,u0,u1,u2,u3,u4,u5,u6,u7,u8,u9:variant;
  var v,v0,v1,v2,v3,v4,v5,v6,v7,v8,v9:variant;
  var w,w0,w1,w2,w3,w4,w5,w6,w7,w8,w9:variant;
  var x,x0,x1,x2,x3,x4,x5,x6,x7,x8,x9:variant;
  var y,y0,y1,y2,y3,y4,y5,y6,y7,y8,y9:variant;
  var z,z0,z1,z2,z3,z4,z5,z6,z7,z8,z9:variant;


 procedure ev3Done;
implementation
uses
  SysUtils,BaseUnix,dateutils,uev3func,uev3utf8,rubiroLeds;

var iProcs:array[0..500] of TInitProc;
    iCount:integer=0;
    dProcs:array[0..500] of TDoneProc;
    dCount:integer=0;

Var
   na : SigActionRec;

procedure ev3Done;
 var i:integer;
begin
 if ev3Finalized then exit;
// writeln(123321);
 ev3Finalized:=true;
// for i:=length(dprocs)-1 downto 0 do begin
//   dprocs[i]();
// end;
 for i:=dCount-1 downto 0 do dprocs[i]();
 ev3.free;
end;

Procedure Finish(sig : cint);cdecl;
begin
 ev3Done();
 fpkill(fpgetpid(), sig)
end;


procedure ev3Init;
 var i:integer;
begin
 ev3:=TEv3.Create;
// for i:=0 to length(iprocs)-1 do begin
//   iprocs[i]();
// end;
 for i:=0 to iCount-1 do iprocs[i]();

 na.sa_Handler:=SigActionHandler(@Finish);
 fillchar(na.Sa_Mask,sizeof(na.sa_mask),#0);
 na.Sa_Flags:=SA_ONESHOT;
 na.Sa_Restorer:=Nil;
 fpSigAction(SIGINT,@na,nil);
 fpSigAction(SIGABRT,@na,nil);
 fpSigAction(SIGQUIT,@na,nil);

end;


procedure PushInit(proc: tinitproc);
begin
//  writeln('pushpush');
//  ev3:=TEv3.Create;
//  setlength(iprocs,length(iprocs)+1);
//  iprocs[length(iprocs)-1]:=proc;
  iprocs[icount]:=proc;
  inc(icount);
end;

procedure PushDone(proc: tdoneproc);
begin
//  writeln('donedone');
//  setlength(dprocs,length(dprocs)+1);
//  dprocs[length(dprocs)-1]:=proc;
  dprocs[dCount]:=proc;
  inc(dCount);
end;

{ TEv3 }

function TEv3.waitEvents(Args: array of const; eLink: TEv3EventLink; out res:TEv3; timeout: dword=high(dword)): boolean;
 var o:array of TEv3; e:array of string;
     i,k:integer;
     R:TEv3;
begin
  res:=nil;
  if High(Args)<2 then exit(false);
  setlength(o,(High(Args)+1) div 2);
  setlength(e,(High(Args)+1) div 2);
  i:=0;k:=0;
  while i<High(Args) do begin
    o[k]:=arg2Obj(args[i]) as TEv3;
    e[k]:=arg2String(args[i+1]);
    //writeln(o[i].classname,' - ',arg2String(args[i+1]));
    inc(i,2);
    inc(k);
  end;
//  for i:=0 to length(e)-1 do writeln(o[i].classname,' + ',e[i]);
  result:=self.waitEvents(o,e,elink,R,timeout);
  res:=R;
end;

function TEv3.waitEvents(Objs: array of TEv3; Events: array of string;
  eLink: TEv3EventLink; out res: TEv3; timeout: dword=high(dword)): boolean;
var
    tm:TDateTime;
    allYes,yes:boolean;
    i:integer;
    cnt:integer;
begin
 cnt:=0;
 try
  tm:=now();
  while true do begin
    inc(cnt); if cnt>20 then begin cnt:=0; ev3Leds.blink; end;
    allYes:=true;
    for i:=0 to length(objs)-1 do begin
      yes:=objs[i].waitEvent(events[i],0);
      if (eLink=evOr) and yes then begin
       // writeln('-- ',events[i]);
        res:=objs[i];
        exit(true);
      end;
      AllYes:=AllYes and yes;
    end;
    if allyes then exit(true);
    if MilliSecondsBetween(now(),tm)>=timeout then exit(false);
    sleep(10);
  end;
 finally
  ev3leds.unblink;
 end;
end;

class function TEv3.varToYes(yes: variant): boolean;
begin
 case utf8lowercase(trim(varToStr(yes))) of
  'нет','no','0','':result:=false
  else result:=true;
 end;
end;

function TEv3.waitAllEvents(objs: array of const; timeout: dword=high(dword)): boolean;
  var res:TEv3;
begin
  result:=waitEvents(objs,evAND,res,timeout);
end;

function TEv3.waitAnyEvent(objs: array of const; timeout: dword=high(dword)): TEv3;
begin
 waitEvents(objs,evOR,result,timeout);
end;


finalization

 ev3Done();
end.

